import { readFileSync } from "fs";
const config = JSON.parse(readFileSync("./config.json").toString());

export default abstract class Config {
	public static ports:IPorts = config.ports;
	public static database:IDatabase = config.database;
	public static session:ISession = config.session;
	public static controllers:IControllers = config.controllers;
	public static accounts:IAccounts = config.accounts;
}

interface IPorts {
	web: number
}

interface IDatabase {
	address: string,
	port: number,
	username: string,
	password: string,
	name: string
}

interface ISession {
	secret: string,
	validity: number,
	length: number
}

interface IControllers {
	enabled: boolean
}

interface ISignup {
	enabled: boolean,
	key: string | null
}

interface IPbkdf2 {
	itterations: number,
	keylength: number
}

interface IAccounts {
	signup: ISignup,
	pbkdf2: IPbkdf2
}